DO WC
CLEAR

lcUrl = "http://localhost/FoxWebServiceInterop/FoxInteropService.asmx?WSDL"

LOCAL oSoap as MSSOAP.SoapClient30
oSoap = CREATEOBJECT("MSSOAP.SoapClient30")

LOCAL loException as Exception
loException = .null.
llError = .f.
TRY 
   oSoap.MSSoapInit(lcUrl)
CATCH  
   llError = .t.
ENDTRY

IF llError
   ? "Unable to load WSDL file from " + lcUrl
   ? oSOAP.FaultString
   return
ENDIF

*** Retrieve authors - returns DataSet returned as NodeList
TRY 
   lcXML =  oSoap.RunQueryXml("select * from Authors","TAuthors")
CATCH TO loException
   llError = .t.
ENDTRY

*** Soft failure - SoapException
IF !EMPTY(oSoap.FaultCode)
   ? oSoap.FaultString
   RETURN
ENDIF   

*** Hard failure in the Web Service 
IF !ISNULL(loException)
   ? loException.Message
   ? loException.ErrorNo
   RETURN
ENDIF


ShowXML(lcXML)

LOCAL oXA AS XMLADAPTER
oXA = CREATEOBJECT("XMLAdapter")
oXA.LOADXML(lcXML,.F.,.T.)

IF (USED("Authors"))
  USE IN AUTHORS
ENDIF

oXA.TABLES[1].TOCURSOR(.F.,"Authors")


*** Set the Buffermode to 5 for the cursor
*** so we can send diffgrams
SET MULTILOCKS ON
CURSORSETPROP("Buffering",5)


BROWSE
