#DEFINE MSSOAP .T.
DO WC

lcWSDL = "http://localhost/FoxWebServiceInterop/FoxInteropService.asmx?WSDL"


IF !USED("Authors")
   lcXML = GetTestDiffGram()
ELSE
   *** Create the DiffGram
   SELECT Authors
   IF GETNEXTMODIFIED(0) = 0
      WAIT WINDOW "No records to update..." NOWAIT
      RETURN
   ENDIF
   oXA = CREATEOBJECT("XMLAdapter")
   oXA.UTF8Encoded = .t.
   oXA.AddTableSchema("Authors")
   oXA.IsDiffgram = .T.
   lcXML = ""
   oXA.ToXML("lcXML",,.f.,.T.,.T.)
ENDIF


#IF MSSOAP
oSOAP = CREATEOBJECT("MSSOAP.SoapClient30")
oSOAP.MSSoapInit(lcWsdl)

*** Retrieve authors - returns DataSet returned as NodeList
LOCAL loException as Exception
loException  = null
   
loDOM = CREATEOBJECT("MSXML2.DomDocument")
loDom.LoadXMl(lcXML)

loNodeList = loDom.DocumentElement.ChildNodes()

ShowXml(loDom.XML)

*** Retrieve authors - returns DataSet returned as NodeList
LOCAL loException as Exception
loException  = null

TRY 
   llResult =  oSOAP.UpdateAuthorData(loNodeList)
CATCH TO loException
   llError = .t.
ENDTRY

IF !ISNULL(loException)
   lcError = oSOAP.FaultString
   if EMPTY(lcError)
      lcError = loException.Message
   ENDIF

   ? loException.ErrorNo
   RETURN
ENDIF

? llResult
RETURN
#ENDIF

loDOM = CREATEOBJECT("MSXML2.DomDocument")
loDom.LoadXML(lcXML)

LOCAL loSOAP as wwSoap
loSOAP = CREATEOBJECT("wwSoap")
loSOAP.AddParameter("Ds",loDOM.DocumentElement.ChildNodes,"nodelist")

? loSOAP.CallWsdlmethod("UpdateAuthorData",lcWsdl)
? loSoap.cErrorMsg


RETURN


FUNCTION GetTestDiffGram
TEXT TO lcXML NOSHOW
<?xml version = "1.0" encoding="Windows-1252" standalone="yes"?>
<VFPData>
   <xsd:schema id="VFPDataSet" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
      <xsd:element name="VFPDataSet" msdata:IsDataSet="true">
         <xsd:complexType>
            <xsd:choice maxOccurs="unbounded">
               <xsd:element name="Authors" minOccurs="0" maxOccurs="unbounded">
                  <xsd:complexType>
                     <xsd:sequence>
                        <xsd:element name="au_id">
                           <xsd:simpleType>
                              <xsd:restriction base="xsd:string">
                                 <xsd:maxLength value="11"/>
                              </xsd:restriction>
                           </xsd:simpleType>
                        </xsd:element>
                        <xsd:element name="au_lname">
                           <xsd:simpleType>
                              <xsd:restriction base="xsd:string">
                                 <xsd:maxLength value="40"/>
                              </xsd:restriction>
                           </xsd:simpleType>
                        </xsd:element>
                        <xsd:element name="au_fname">
                           <xsd:simpleType>
                              <xsd:restriction base="xsd:string">
                                 <xsd:maxLength value="20"/>
                              </xsd:restriction>
                           </xsd:simpleType>
                        </xsd:element>
                        <xsd:element name="phone">
                           <xsd:simpleType>
                              <xsd:restriction base="xsd:string">
                                 <xsd:maxLength value="12"/>
                              </xsd:restriction>
                           </xsd:simpleType>
                        </xsd:element>
                        <xsd:element name="address" minOccurs="0">
                           <xsd:simpleType>
                              <xsd:restriction base="xsd:string">
                                 <xsd:maxLength value="40"/>
                              </xsd:restriction>
                           </xsd:simpleType>
                        </xsd:element>
                        <xsd:element name="city" minOccurs="0">
                           <xsd:simpleType>
                              <xsd:restriction base="xsd:string">
                                 <xsd:maxLength value="20"/>
                              </xsd:restriction>
                           </xsd:simpleType>
                        </xsd:element>
                        <xsd:element name="state" minOccurs="0">
                           <xsd:simpleType>
                              <xsd:restriction base="xsd:string">
                                 <xsd:maxLength value="2"/>
                              </xsd:restriction>
                           </xsd:simpleType>
                        </xsd:element>
                        <xsd:element name="zip" minOccurs="0">
                           <xsd:simpleType>
                              <xsd:restriction base="xsd:string">
                                 <xsd:maxLength value="5"/>
                              </xsd:restriction>
                           </xsd:simpleType>
                        </xsd:element>
                        <xsd:element name="contract" type="xsd:boolean"/>
                     </xsd:sequence>
                     <xsd:anyAttribute namespace="urn:schemas-microsoft-com:xml-msdata urn:schemas-microsoft-com:xml-diffgram-v1" processContents="lax"/>
                  </xsd:complexType>
               </xsd:element>
            </xsd:choice>
         </xsd:complexType>
      </xsd:element>
   </xsd:schema>
   <diffgr:diffgram xmlns:msdata="urn:schemas-microsoft-com:xml-msdata" xmlns:diffgr="urn:schemas-microsoft-com:xml-diffgram-v1">
      <VFPDataSet xmlns="">
         <Authors diffgr:id="authors_1" msdata:rowOrder="1" diffgr:hasChanges="modified">
            <au_id>648-92-1872</au_id>
            <au_lname>Blotchet-Halls XXXX</au_lname>
            <au_fname>Reginald</au_fname>
            <phone>503 745-6402</phone>
            <address>55 Hillsdale Bl.</address>
            <city>Corvallis</city>
            <state>OR</state>
            <zip>97330</zip>
            <contract>true</contract>
         </Authors>
      </VFPDataSet>
      <diffgr:before>
         <Authors diffgr:id="authors_1" msdata:rowOrder="1" xmlns="">
            <au_id>648-92-1872</au_id>
            <au_lname>Blotchet-Halls</au_lname>
            <au_fname>Reginald</au_fname>
            <phone>503 745-6402</phone>
            <address>55 Hillsdale Bl.</address>
            <city>Corvallis</city>
            <state>OR</state>
            <zip>97330</zip>
            <contract>true</contract>
         </Authors>
      </diffgr:before>
   </diffgr:diffgram>
</VFPData>
ENDTEXT

RETURN lcXML