DO WC
CLEAR
lcWSDL = "http://localhost/FoxWebServiceInterop/FoxInteropService.asmx?WSDL"
lcXML = GetEntityXml()

loDom = CREATEOBJECT("MSXML2.DomDocument")
loDom.LoadXml(lcXML)

*ShowXml(loDom.DocumentElement.Xml)

#IF .F.
*** Using MSSOAP Toolkit
loSOAP = CREATEOBJECT("MSSOAP.SoapClient30")
loSOAP.MSSoapInit(lcWSDL)
llResult = loSOAP.UpdateAuthorEntity(loDom.DocumentElement.ChildNodes)
? llResult
? loSOAP.FaultString
RETURN
#ENDIF

*** Using wwSOAP
LOCAL loSoap as wwSOAP
loSoap = CREATEOBJECT('wwSoap')
loSoap.Parseservicewsdl(lcWSDL,.T.)

loAuthor = GetAuthorProxyObject()
loAuthor.au_lname = "Strahl"
loAuthor.au_fname = "Rick"
loAuthor.Phone = "808 123-1211"
loAuthor.Address = "32 Kaiea Place"
loAuthor.City = "Paia"
loAuthor.State = "HI"
loAUthor.Zip = "96779"
loAuthor.Contract = 0

lcXML = loSOAP.CreateObjectXmlFromSchema(loAuthor,"AuthorEntity")
? lcXML
ShowText(lcXML)

loSOAP.AddParameter("UpdatedAuthor",loDom.DocumentElement.ChildNodes,;
                    "NodeList")
llResult = loSOAP.CallWsdlMethod("UpdateAuthorEntity",lcWSDL)
? loSOAP.cErrorMsg
? llResult
RETURN

*** This XML would have to be generated manually
*** since it's mixed case. 
FUNCTION GetEntityXml
** xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns="http://www.west-wind.com/FoxWebServiceInterop/"
TEXT TO lcXML NOSHOW
<AuthorsEntity>
  <UseColumns>false</UseColumns>
  <PhoneNumbers>
    <HomePhone>808 579-8342</HomePhone>
    <WorkPhone>808 579-8342</WorkPhone>
    <Fax>808 801-1231</Fax>
    <ServiceStarted>1900-01-01T00:00:00.0000000-10:00</ServiceStarted>
  </PhoneNumbers>
  <Au_id>486-29-1789</Au_id>
  <Au_lname>Locksley IV</Au_lname>
  <Au_fname>Charlene</Au_fname>
  <Phone>415 585-4620</Phone>
  <Address>18 Broadway Av.</Address>
  <City>San Francisco</City>
  <State>CA</State>
  <Zip>94130</Zip>
  <Contract>true</Contract>
</AuthorsEntity>
ENDTEXT
RETURN lcXML

FUNCTION GetAuthorProxyObject()

*** Manunally parse the result back into an object
loAuthor = CREATEOBJECT("Relation")
loAuthor.AddProperty("Au_id","")
loAuthor.AddProperty("Au_lname","")
loAuthor.AddProperty("Au_fname","")
loAuthor.AddProperty("Phone","")
loAuthor.AddProperty("Address","")
loAuthor.AddProperty("City","")
loAuthor.AddProperty("State","")
loAuthor.AddProperty("Zip","")
loAuthor.AddProperty("Contract",.f.)

loAuthor.AddProperty("PhoneNumbers",CREATEOBJECT("RELATION"))
loAuthor.PhoneNumbers.AddProperty("HomePhone","")
loAuthor.PhoneNumbers.AddProperty("WorkPhone","")
loAuthor.PhoneNumbers.AddProperty("Fax","")
loAuthor.PhoneNumbers.AddProperty("ServiceStarted",DATETIME())


*** Code to add an array for invoices
loAuthor.AddProperty("Invoices")
*DIMENSION loAuthor.Invoices[2]


*LOCAL loInvoices as Collection
loAuthor.Invoices = CREATEOBJECT("Collection")

loInv = CREATEOBJECT("Empty")
ADDPROPERTY(loInv,"InvoiceNumber","9")
ADDPROPERTY(loInv,"InvoiceDate",{05/10/2004 :})
ADDPROPERTY(loInv,"InvoiceTotal",102.00)

loAuthor.Invoices.Add(loInv)
*loAuthor.Invoices[1] = loInv


loInv = CREATEOBJECT("Empty")
ADDPROPERTY(loInv,"InvoiceNumber","10")
ADDPROPERTY(loInv,"InvoiceDate",{01/10/2004 :})
ADDPROPERTY(loInv,"InvoiceTotal",199.90)

*loAuthor.Invoices[2] = loInv
loAuthor.Invoices.Add(loInv)

RETURN loAuthor