*** wwSOAP Proxy Header - DO NOT REMOVE THIS LINE

* *** Load Class Libraries
DO wwSoap 
SET PROCEDURE TO FoxInteropServiceProxy ADDITIVE
RETURN

*!*   LOCAL oProxy as FoxInteropServiceProxy
*!*   oProxy = CREATEOBJECT("FoxInteropServiceProxy",0,.T.)
*!*   oProxy.nTimeout = 5
*!*   oProxy.LoadWSDL()

*!*   ? oProxy.HelloWorld("Test")

*!*   ? oProxy.cErrorMsg

*** End wwSOAP Proxy Header - DO NOT REMOVE THIS LINE


*** wwSOAP Proxy Class for FoxInteropService - generated 10/01/2004 14:48:06
DEFINE CLASS FoxInteropServiceProxy as wwSOAPProxy

cWSDLUrl = "http://localhost/FoxWebServiceInterop/FoxInteropService.asmx?WSDL"

*** If you override any methods and want to preserve the override 
*** between generations use the section below - you still have 
*** to remove the method from the generated class code below

*** wwSOAP Overridden Method Code - DO NOT REMOVE THIS LINE

*** End wwSOAP Overridden Method Code - DO NOT REMOVE THIS LINE

FUNCTION HelloWorld(Name as string) AS string
LOCAL lvResult

THIS.SetError()

DO CASE
*** wwSOAP Client
CASE THIS.nClientMode = 0  
   THIS.oSOAP.AddParameter("RESET")

   THIS.oSOAP.AddParameter("Name",Name)

   lvResult=THIS.oSOAP.CallWSDLMethod("HelloWorld",THIS.oSDL)
   IF THIS.oSOAP.lError
      THIS.SetError(THIS.oSOAP.cErrorMsg)
      RETURN .F.
   ENDIF

   RETURN lvResult

*** MSSOAP Client
CASE THIS.nClientMode = 1  
   LOCAL loException

   TRY
      this.SetMSSOAPConnectionProperties()
      lvResult = THIS.oSOAP.HelloWorld(Name)
   CATCH TO loException
      this.lError = .t.
      this.cErrorMsg = this.oSoap.FaultString
      IF EMPTY(this.cErrorMsg)
         this.cErrorMsg = loException.Message
      ENDIF
   ENDTRY

   IF this.lError
      RETURN .F.
   ENDIF

   RETURN lvResult
ENDCASE
ENDFUNC

FUNCTION GetServerTime() AS datetime
LOCAL lvResult

THIS.SetError()

DO CASE
*** wwSOAP Client
CASE THIS.nClientMode = 0  
   THIS.oSOAP.AddParameter("RESET")


   lvResult=THIS.oSOAP.CallWSDLMethod("GetServerTime",THIS.oSDL)
   IF THIS.oSOAP.lError
      THIS.SetError(THIS.oSOAP.cErrorMsg)
      RETURN .F.
   ENDIF

   RETURN lvResult

*** MSSOAP Client
CASE THIS.nClientMode = 1  
   LOCAL loException

   TRY
      this.SetMSSOAPConnectionProperties()
      lvResult = THIS.oSOAP.GetServerTime()
   CATCH TO loException
      this.lError = .t.
      this.cErrorMsg = this.oSoap.FaultString
      IF EMPTY(this.cErrorMsg)
         this.cErrorMsg = loException.Message
      ENDIF
   ENDTRY

   IF this.lError
      RETURN .F.
   ENDIF

   RETURN lvResult
ENDCASE
ENDFUNC

FUNCTION RunQueryXml(Sql as string,TableName as string) AS string
LOCAL lvResult

THIS.SetError()

DO CASE
*** wwSOAP Client
CASE THIS.nClientMode = 0  
   THIS.oSOAP.AddParameter("RESET")

   THIS.oSOAP.AddParameter("Sql",Sql)
   THIS.oSOAP.AddParameter("TableName",TableName)

   lvResult=THIS.oSOAP.CallWSDLMethod("RunQueryXml",THIS.oSDL)
   IF THIS.oSOAP.lError
      THIS.SetError(THIS.oSOAP.cErrorMsg)
      RETURN .F.
   ENDIF

   RETURN lvResult

*** MSSOAP Client
CASE THIS.nClientMode = 1  
   LOCAL loException

   TRY
      this.SetMSSOAPConnectionProperties()
      lvResult = THIS.oSOAP.RunQueryXml(Sql,TableName)
   CATCH TO loException
      this.lError = .t.
      this.cErrorMsg = this.oSoap.FaultString
      IF EMPTY(this.cErrorMsg)
         this.cErrorMsg = loException.Message
      ENDIF
   ENDTRY

   IF this.lError
      RETURN .F.
   ENDIF

   RETURN lvResult
ENDCASE
ENDFUNC

FUNCTION RunQuery(Sql as string,TableName as string) AS variant
LOCAL lvResult

THIS.SetError()

DO CASE
*** wwSOAP Client
CASE THIS.nClientMode = 0  
   THIS.oSOAP.AddParameter("RESET")

   THIS.oSOAP.AddParameter("Sql",Sql)
   THIS.oSOAP.AddParameter("TableName",TableName)

   lvResult=THIS.oSOAP.CallWSDLMethod("RunQuery",THIS.oSDL)
   IF THIS.oSOAP.lError
      THIS.SetError(THIS.oSOAP.cErrorMsg)
      RETURN .F.
   ENDIF

   RETURN lvResult

*** MSSOAP Client
CASE THIS.nClientMode = 1  
   LOCAL loException

   TRY
      this.SetMSSOAPConnectionProperties()
      lvResult = THIS.oSOAP.RunQuery(Sql,TableName)
   CATCH TO loException
      this.lError = .t.
      this.cErrorMsg = this.oSoap.FaultString
      IF EMPTY(this.cErrorMsg)
         this.cErrorMsg = loException.Message
      ENDIF
   ENDTRY

   IF this.lError
      RETURN .F.
   ENDIF

   RETURN lvResult
ENDCASE
ENDFUNC

FUNCTION GetAuthors(Name as string) AS variant
LOCAL lvResult

THIS.SetError()

DO CASE
*** wwSOAP Client
CASE THIS.nClientMode = 0  
   THIS.oSOAP.AddParameter("RESET")

   THIS.oSOAP.AddParameter("Name",Name)

   lvResult=THIS.oSOAP.CallWSDLMethod("GetAuthors",THIS.oSDL)
   IF THIS.oSOAP.lError
      THIS.SetError(THIS.oSOAP.cErrorMsg)
      RETURN .F.
   ENDIF

   RETURN lvResult

*** MSSOAP Client
CASE THIS.nClientMode = 1  
   LOCAL loException

   TRY
      this.SetMSSOAPConnectionProperties()
      lvResult = THIS.oSOAP.GetAuthors(Name)
   CATCH TO loException
      this.lError = .t.
      this.cErrorMsg = this.oSoap.FaultString
      IF EMPTY(this.cErrorMsg)
         this.cErrorMsg = loException.Message
      ENDIF
   ENDTRY

   IF this.lError
      RETURN .F.
   ENDIF

   RETURN lvResult
ENDCASE
ENDFUNC

FUNCTION UpdateAuthorData(Ds as variant) AS boolean
LOCAL lvResult

THIS.SetError()

DO CASE
*** wwSOAP Client
CASE THIS.nClientMode = 0  
   THIS.oSOAP.AddParameter("RESET")

   THIS.oSOAP.AddParameter("Ds",Ds)

   lvResult=THIS.oSOAP.CallWSDLMethod("UpdateAuthorData",THIS.oSDL)
   IF THIS.oSOAP.lError
      THIS.SetError(THIS.oSOAP.cErrorMsg)
      RETURN .F.
   ENDIF

   RETURN lvResult

*** MSSOAP Client
CASE THIS.nClientMode = 1  
   LOCAL loException

   TRY
      this.SetMSSOAPConnectionProperties()
      lvResult = THIS.oSOAP.UpdateAuthorData(Ds)
   CATCH TO loException
      this.lError = .t.
      this.cErrorMsg = this.oSoap.FaultString
      IF EMPTY(this.cErrorMsg)
         this.cErrorMsg = loException.Message
      ENDIF
   ENDTRY

   IF this.lError
      RETURN .F.
   ENDIF

   RETURN lvResult
ENDCASE
ENDFUNC

FUNCTION UpdateAuthorDataXml(lcXml as string) AS boolean
LOCAL lvResult

THIS.SetError()

DO CASE
*** wwSOAP Client
CASE THIS.nClientMode = 0  
   THIS.oSOAP.AddParameter("RESET")

   THIS.oSOAP.AddParameter("lcXml",lcXml)

   lvResult=THIS.oSOAP.CallWSDLMethod("UpdateAuthorDataXml",THIS.oSDL)
   IF THIS.oSOAP.lError
      THIS.SetError(THIS.oSOAP.cErrorMsg)
      RETURN .F.
   ENDIF

   RETURN lvResult

*** MSSOAP Client
CASE THIS.nClientMode = 1  
   LOCAL loException

   TRY
      this.SetMSSOAPConnectionProperties()
      lvResult = THIS.oSOAP.UpdateAuthorDataXml(lcXml)
   CATCH TO loException
      this.lError = .t.
      this.cErrorMsg = this.oSoap.FaultString
      IF EMPTY(this.cErrorMsg)
         this.cErrorMsg = loException.Message
      ENDIF
   ENDTRY

   IF this.lError
      RETURN .F.
   ENDIF

   RETURN lvResult
ENDCASE
ENDFUNC

FUNCTION GetAuthorArray(Name as string) AS variant
LOCAL lvResult

THIS.SetError()

DO CASE
*** wwSOAP Client
CASE THIS.nClientMode = 0  
   THIS.oSOAP.AddParameter("RESET")

   THIS.oSOAP.AddParameter("Name",Name)

   lvResult=THIS.oSOAP.CallWSDLMethod("GetAuthorArray",THIS.oSDL)
   IF THIS.oSOAP.lError
      THIS.SetError(THIS.oSOAP.cErrorMsg)
      RETURN .F.
   ENDIF

   RETURN lvResult

*** MSSOAP Client
CASE THIS.nClientMode = 1  
   LOCAL loException

   TRY
      this.SetMSSOAPConnectionProperties()
      lvResult = THIS.oSOAP.GetAuthorArray(Name)
   CATCH TO loException
      this.lError = .t.
      this.cErrorMsg = this.oSoap.FaultString
      IF EMPTY(this.cErrorMsg)
         this.cErrorMsg = loException.Message
      ENDIF
   ENDTRY

   IF this.lError
      RETURN .F.
   ENDIF

   RETURN lvResult
ENDCASE
ENDFUNC

FUNCTION GetAuthorsList() AS variant
LOCAL lvResult

THIS.SetError()

DO CASE
*** wwSOAP Client
CASE THIS.nClientMode = 0  
   THIS.oSOAP.AddParameter("RESET")


   lvResult=THIS.oSOAP.CallWSDLMethod("GetAuthorsList",THIS.oSDL)
   IF THIS.oSOAP.lError
      THIS.SetError(THIS.oSOAP.cErrorMsg)
      RETURN .F.
   ENDIF

   RETURN lvResult

*** MSSOAP Client
CASE THIS.nClientMode = 1  
   LOCAL loException

   TRY
      this.SetMSSOAPConnectionProperties()
      lvResult = THIS.oSOAP.GetAuthorsList()
   CATCH TO loException
      this.lError = .t.
      this.cErrorMsg = this.oSoap.FaultString
      IF EMPTY(this.cErrorMsg)
         this.cErrorMsg = loException.Message
      ENDIF
   ENDTRY

   IF this.lError
      RETURN .F.
   ENDIF

   RETURN lvResult
ENDCASE
ENDFUNC

FUNCTION GetAuthor(ID as string) AS variant
LOCAL lvResult

THIS.SetError()

DO CASE
*** wwSOAP Client
CASE THIS.nClientMode = 0  
   THIS.oSOAP.AddParameter("RESET")

   THIS.oSOAP.AddParameter("ID",ID)

   lvResult=THIS.oSOAP.CallWSDLMethod("GetAuthor",THIS.oSDL)
   IF THIS.oSOAP.lError
      THIS.SetError(THIS.oSOAP.cErrorMsg)
      RETURN .F.
   ENDIF

   RETURN lvResult

*** MSSOAP Client
CASE THIS.nClientMode = 1  
   LOCAL loException

   TRY
      this.SetMSSOAPConnectionProperties()
      lvResult = THIS.oSOAP.GetAuthor(ID)
   CATCH TO loException
      this.lError = .t.
      this.cErrorMsg = this.oSoap.FaultString
      IF EMPTY(this.cErrorMsg)
         this.cErrorMsg = loException.Message
      ENDIF
   ENDTRY

   IF this.lError
      RETURN .F.
   ENDIF

   RETURN lvResult
ENDCASE
ENDFUNC

FUNCTION GetAuthorEntity(Id as string) AS variant
LOCAL lvResult

THIS.SetError()

DO CASE
*** wwSOAP Client
CASE THIS.nClientMode = 0  
   THIS.oSOAP.AddParameter("RESET")

   THIS.oSOAP.AddParameter("Id",Id)

   lvResult=THIS.oSOAP.CallWSDLMethod("GetAuthorEntity",THIS.oSDL)
   IF THIS.oSOAP.lError
      THIS.SetError(THIS.oSOAP.cErrorMsg)
      RETURN .F.
   ENDIF

   RETURN lvResult

*** MSSOAP Client
CASE THIS.nClientMode = 1  
   LOCAL loException

   TRY
      this.SetMSSOAPConnectionProperties()
      lvResult = THIS.oSOAP.GetAuthorEntity(Id)
   CATCH TO loException
      this.lError = .t.
      this.cErrorMsg = this.oSoap.FaultString
      IF EMPTY(this.cErrorMsg)
         this.cErrorMsg = loException.Message
      ENDIF
   ENDTRY

   IF this.lError
      RETURN .F.
   ENDIF

   RETURN lvResult
ENDCASE
ENDFUNC

FUNCTION UpdateAuthorEntity(UpdatedAuthor as variant) AS boolean
LOCAL lvResult

THIS.SetError()

DO CASE
*** wwSOAP Client
CASE THIS.nClientMode = 0  
   THIS.oSOAP.AddParameter("RESET")

   THIS.oSOAP.AddParameter("UpdatedAuthor",UpdatedAuthor)

   lvResult=THIS.oSOAP.CallWSDLMethod("UpdateAuthorEntity",THIS.oSDL)
   IF THIS.oSOAP.lError
      THIS.SetError(THIS.oSOAP.cErrorMsg)
      RETURN .F.
   ENDIF

   RETURN lvResult

*** MSSOAP Client
CASE THIS.nClientMode = 1  
   LOCAL loException

   TRY
      this.SetMSSOAPConnectionProperties()
      lvResult = THIS.oSOAP.UpdateAuthorEntity(UpdatedAuthor)
   CATCH TO loException
      this.lError = .t.
      this.cErrorMsg = this.oSoap.FaultString
      IF EMPTY(this.cErrorMsg)
         this.cErrorMsg = loException.Message
      ENDIF
   ENDTRY

   IF this.lError
      RETURN .F.
   ENDIF

   RETURN lvResult
ENDCASE
ENDFUNC

FUNCTION GetAuthorsXml(Name as string) AS string
LOCAL lvResult

THIS.SetError()

DO CASE
*** wwSOAP Client
CASE THIS.nClientMode = 0  
   THIS.oSOAP.AddParameter("RESET")

   THIS.oSOAP.AddParameter("Name",Name)

   lvResult=THIS.oSOAP.CallWSDLMethod("GetAuthorsXml",THIS.oSDL)
   IF THIS.oSOAP.lError
      THIS.SetError(THIS.oSOAP.cErrorMsg)
      RETURN .F.
   ENDIF

   RETURN lvResult

*** MSSOAP Client
CASE THIS.nClientMode = 1  
   LOCAL loException

   TRY
      this.SetMSSOAPConnectionProperties()
      lvResult = THIS.oSOAP.GetAuthorsXml(Name)
   CATCH TO loException
      this.lError = .t.
      this.cErrorMsg = this.oSoap.FaultString
      IF EMPTY(this.cErrorMsg)
         this.cErrorMsg = loException.Message
      ENDIF
   ENDTRY

   IF this.lError
      RETURN .F.
   ENDIF

   RETURN lvResult
ENDCASE
ENDFUNC

FUNCTION ExceptionTest() AS void
LOCAL lvResult

THIS.SetError()

DO CASE
*** wwSOAP Client
CASE THIS.nClientMode = 0  
   THIS.oSOAP.AddParameter("RESET")


   lvResult=THIS.oSOAP.CallWSDLMethod("ExceptionTest",THIS.oSDL)
   IF THIS.oSOAP.lError
      THIS.SetError(THIS.oSOAP.cErrorMsg)
      RETURN .F.
   ENDIF

   RETURN lvResult

*** MSSOAP Client
CASE THIS.nClientMode = 1  
   LOCAL loException

   TRY
      this.SetMSSOAPConnectionProperties()
      lvResult = THIS.oSOAP.ExceptionTest()
   CATCH TO loException
      this.lError = .t.
      this.cErrorMsg = this.oSoap.FaultString
      IF EMPTY(this.cErrorMsg)
         this.cErrorMsg = loException.Message
      ENDIF
   ENDTRY

   IF this.lError
      RETURN .F.
   ENDIF

   RETURN lvResult
ENDCASE
ENDFUNC

FUNCTION ReturnXml() AS variant
LOCAL lvResult

THIS.SetError()

DO CASE
*** wwSOAP Client
CASE THIS.nClientMode = 0  
   THIS.oSOAP.AddParameter("RESET")


   lvResult=THIS.oSOAP.CallWSDLMethod("ReturnXml",THIS.oSDL)
   IF THIS.oSOAP.lError
      THIS.SetError(THIS.oSOAP.cErrorMsg)
      RETURN .F.
   ENDIF

   RETURN lvResult

*** MSSOAP Client
CASE THIS.nClientMode = 1  
   LOCAL loException

   TRY
      this.SetMSSOAPConnectionProperties()
      lvResult = THIS.oSOAP.ReturnXml()
   CATCH TO loException
      this.lError = .t.
      this.cErrorMsg = this.oSoap.FaultString
      IF EMPTY(this.cErrorMsg)
         this.cErrorMsg = loException.Message
      ENDIF
   ENDTRY

   IF this.lError
      RETURN .F.
   ENDIF

   RETURN lvResult
ENDCASE
ENDFUNC

FUNCTION ReturnBytes() AS variant
LOCAL lvResult

THIS.SetError()

DO CASE
*** wwSOAP Client
CASE THIS.nClientMode = 0  
   THIS.oSOAP.AddParameter("RESET")


   lvResult=THIS.oSOAP.CallWSDLMethod("ReturnBytes",THIS.oSDL)
   IF THIS.oSOAP.lError
      THIS.SetError(THIS.oSOAP.cErrorMsg)
      RETURN .F.
   ENDIF

   RETURN lvResult

*** MSSOAP Client
CASE THIS.nClientMode = 1  
   LOCAL loException

   TRY
      this.SetMSSOAPConnectionProperties()
      lvResult = THIS.oSOAP.ReturnBytes()
   CATCH TO loException
      this.lError = .t.
      this.cErrorMsg = this.oSoap.FaultString
      IF EMPTY(this.cErrorMsg)
         this.cErrorMsg = loException.Message
      ENDIF
   ENDTRY

   IF this.lError
      RETURN .F.
   ENDIF

   RETURN lvResult
ENDCASE
ENDFUNC

ENDDEFINE