using System;
using System.Data.SqlClient;

namespace FoxWebServiceInterop
{
	/// <summary>
	/// Summary description for busCustomer.
	/// </summary>
	public class busAuthor : SimpleBusObj
	{
		public busAuthor() 
		{
			this.TableName = "Authors";
			this.ConnectionString = "server=(local);database=pubs;uid=demo;pwd=demo";
			this.PkField = "au_ID";
		}

		/// <summary>
		/// Returns a customer table in the Class's DataSet property named CustomerList
		/// </summary>
		/// <param name="Name"></param>
		public int GetAuthors(string Name,string Fields,string OutputTable) 
		{
			if (Name == null)
				Name = "";

			Name += "%";
			return this.Execute("select * from " + this.TableName + " where au_lname like @Name ORDER BY au_lname",OutputTable,new SqlParameter("@Name",Name) );
		}

		/// <summary>
		/// Returns a customer table in the Class's DataSet property named CustomerList
		/// </summary>
		/// <param name="Name"></param>
		public int GetAuthors(string Name)  
		{
			return this.GetAuthors(Name,"*","AuthorList");
		}

	}
}
