

using System;
using System.Data;
using System.Collections;

using FoxWebServiceInterop;
using Westwind.Tools;

namespace FoxWebServiceInterop
{
	[Serializable()]
	public class SimpleEntity 
	{
		public void LoadRow(DataRow Row) 
		{
			wwDataUtils.CopyObjectFromDataRow(Row,this);
		}
		public void SaveRow(DataRow Row) 
		{
			wwDataUtils.CopyObjectToDataRow(Row,this);
		}

		public ArrayList CreateEntityList(DataTable Table) 
		{	
			ArrayList EntityList = new ArrayList();
			foreach(DataRow Row in Table.Rows) 
			{
				EntityList.Add( new AuthorEntity() );
			}

			return EntityList;
		}
	}

	[Serializable()]
	public class AuthorEntity : SimpleEntity
	{			
		public AuthorEntity()
		{}

		protected DataRow Row;

		public PhoneInfo PhoneNumbers = new PhoneInfo();

		public String Au_id;
		public String Au_lname;
		public String Au_fname;
		public String Phone;
		public String Address;
		public String City;
		public String State;
		public String Zip;
		public Boolean Contract;
	}


	[Serializable()]
	public class PhoneInfo 
	{
		public string HomePhone = "808 579-8342";
		public string WorkPhone = "808 579-8342";
		public string Fax = "808 801-1231";
		public DateTime ServiceStarted = Convert.ToDateTime("01/01/1900");
	}
}