DO WC
CLEAR

lcUrl = "http://localhost/FoxWebServiceInterop/FoxInteropService.asmx?WSDL"

LOCAL o as MSSOAP.SoapClient30
o = CREATEOBJECT("MSSOAP.SoapClient30")

LOCAL loException as Exception
loException = null
llError=.f.
TRY 
   o.MSSoapInit(lcUrl)
CATCH TO loException 
   llError = .t.
ENDTRY

IF llError 
   ? "Unable to load WSDL file from " + lcUrl
   return
ENDIF

*** Retrieve authors - returns DataSet returned as NodeList
LOCAL loException as Exception
loException  = null

TRY 
   loNL =  o.GetAuthors("")
CATCH TO loException
   llError = .t.
ENDTRY

IF (o.FaultCode != "")
   ? o.FaultString
   return
ENDIF

IF !ISNULL(loException)
   ? loException.Message
   ? loException.ErrorNo
   RETURN
ENDIF

*** Grab the XML - should be a dataset
loDOM = loNL.item(0).parentNode 
lcXML = loDOM.Xml

ShowXML(lcXML)

LOCAL oXA AS XMLADAPTER
oXA = CREATEOBJECT("XMLAdapter")
oXA.LOADXML(lcXML,.F.,.T.)
*oXA.Attach(loDOM)

IF (USED("Authors"))
  USE IN AUTHORS
ENDIF

oXA.TABLES[1].TOCURSOR(.F.,"Authors")

*** Set the Buffermode to 5 for the cursor
*** so we can send diffgrams
SET MULTILOCKS ON
CURSORSETPROP("Buffering",5)

BROWSE
